/** SGX

The   sss    gggg x   x   
     s      g      x x    Engine
      sss   g  gg   x
         s  g   g  x x          Copyright 1995-2009.
     ssss    gggg x   x         Steven Goodwin. All Rights Reserved.
    
This version has been released under the GNU Public License v2.0.

Please see the license files for details.

File: sgx/include/sgx/graphics/drawsurface_manager.hpp

*/

#ifndef SGX_GRAPHICS_DRAWSURFACE_MANAGER_HPP
#define SGX_GRAPHICS_DRAWSURFACE_MANAGER_HPP	1

class CSGXDrawSurfaceManager {
public:
	static CSGXDrawSurfaceManager *get();
	
	CSGXDrawSurfaceManager();

	virtual CSGXDrawSurface *createSurface(tUINT32 width, tUINT32 height);
	virtual CSGXDrawSurface *createDisplaySurface(tUINT32 width, tUINT32 height);
	virtual CSGXDrawSurface *createWorkingSurface(tUINT32 width, tUINT32 height);

	virtual CSGXDrawSurface *getDisplaySurface() const;
	virtual CSGXDrawSurface *getWorkingSurface() const;

protected:
	static CSGXDrawSurfaceManager *m_pSingleton;

	CSGXDrawSurface *m_pDisplay;
	CSGXDrawSurface *m_pWorking;
};

#endif	// SGX_GRAPHICS_DRAWSURFACE_MANAGER_HPP

